package com.eneraptor.hci

import groovy.sql.*
import java.sql.*

class ConfigController {
	
	def dataSource

    def main = { }
	
	def hci = {
		
		def allDevices = HardwareSet.get(session.hwSet.id).devices
		
		[conf: InternalConfig, devices: allDevices]		
	}
	
	def addDevice = {
	}
	
	def addDeviceSave = {
		def newDevice = new DeviceInfo(params)
		HardwareSet.get(session.hwSet.id).addToDevices(newDevice)
		if(newDevice.validate() && (params.inputDevice || params.outputDevice)) {
			newDevice.save()
			flash['confirms'] = "<p>New device added successfully.</p>"
			redirect(action:'hci')
		} else {
			flash['errors'] = "<p>New device was not saved. Check input data.</p>"
			if(!params.inputDevice && !params.outputDevice)
				flash['errors'] += "<p>Device must be capable of making masurements, actions or both. You have selected none.</p>"
			redirect(action:'addDevice', params: params)
		}
	}
	
	def deleteHciEntry = {
		
		def deviceToBeDeleted = DeviceInfo.findById(params.id)
		
		if(deviceToBeDeleted) {
			deviceToBeDeleted.delete()
			flash['confirms'] = "<p>Device deleted succesfully.</p>"
		} else {
			flash['errors'] = "<p>There was no device deleted.</p><p>There was no device with id ${params.id}.</p>"
		}
		redirect(action: 'hci')
		
	}
	
	def changeHciEntry = {
		
		def deviceToBeChanged = DeviceInfo.findById(params.id)
		if(!deviceToBeChanged) {
			flash['errors'] = "<p>There is no device with id ${params.id}.</p>"
			redirect(action: 'hci')
			return false
		}
		deviceToBeChanged.getProperties()
    }
	
	def changeHciEntrySave = {
		
		def deviceToBeUpdated = DeviceInfo.findById(params.id)
		deviceToBeUpdated.properties = params
		if(deviceToBeUpdated.save()) {
			flash['confirms'] = "<p>Device updated succesfully.</p>"
			redirect(action: 'hci')
		} else {
			flash['errors'] = "<p>Device was not changed.</p>"
			redirect(action:'changeHciEntry', params: params)
		}
		
	}
	
	def dbInfo = {
		
		List databaseInfo = new ArrayList()
		def db_sql = new Sql(dataSource)
		db_sql.eachRow "SHOW ALL", {
			databaseInfo << it.toRowResult()
		}
		
		[databaseInfo: databaseInfo]
		
	}
	
	def logic = {
		
		def hwSet = session.hwSet
		
		[hwSet:hwSet]
		
	}
	
	def connection = {
		
		def hwSet = session.hwSet
		
		[hwSet: hwSet]
		
	}
	
	def saveConnection = {
		
		if(params['logic-ip'] == 'localhost') params['logic-ip'] = '127.0.0.1'
		
		if(params['logic-ip'] && params['logic-port'] && params['logic-port'].isInteger()) {
			
			session.hwSet.IPaddress = params['logic-ip']
			session.hwSet.portNumber = (params['logic-port'] as int)
			HardwareSet toChange = HardwareSet.get(session.hwSet.id)
			toChange.IPaddress = params['logic-ip']
			toChange.portNumber = (params['logic-port'] as int)
			toChange.save()
			flash['confirms'] = "<p>Changes saved.</p>"
			redirect(action: 'connection')
		} else {
			flash['errors'] = "<p>Could not save changes.</p><p>Logic IP address and port fields cannot be blank. Port number must be an integer.</p>"
			redirect(action: 'connection')
		}
		
	}
	
	def dbExec = {
		
		if(params['sqlQuery']) {
			
			flash['confirms'] = null
			flash['errors'] = null
			
			def db_sql = new Sql(dataSource)
			List rows
			List keys = new ArrayList()
			boolean wasError = false
			try {
				rows = db_sql.rows(params['sqlQuery'])
				rows[0].each {
					keys << it.key
				}
				flash['confirms'] = "<p>SQL query executed succesfully. Chrck returned rows below.</p>"
			} catch (SQLException e) {
				rows = new ArrayList()
				if(e.getSQLState().equals("02000")) {
					keys << 'SQL query result'
					rows << ['SQL query result' : 'No rows were returned.']
					flash['confirms'] = "<p>SQL query executed succesfully.</p>"
				} else {
					rows << e
					rows << e.getSQLState()
					wasError = true
					flash['errors'] = "<p>There was an error while executing the SQL query. Check the report below.</p><p>The query was not executed</p>"
				}
			}
			return [sqlResult: rows, keys: keys, wasError: wasError]
		}
		
	}
	
	def getHelp = {
		[what : params.what]
	}
	
	def database = { }
	
}
